﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LevelGenerator : MonoBehaviour {
	public GameObject groundPrefab;
	public GameObject levelPrefab;
	public GameObject coinPrefab;
	public GameObject monsterPrefab;
	public GameObject boxPrefab;
	// Use this for initialization

	float groundProb = 0.7f;
	float level1Prob = 0.3f;
	float level2Prob = 0.3f;
	float coinProb = 0.1f;
	float boxProb = 0.2f;
	float monsterProb = 0.2f;

	void generateGameObjects(int i, int level)
	{
		float rand = Random.value;
		if (rand < coinProb) {
			GameObject coin = Instantiate (coinPrefab);
			coin.transform.Translate (new Vector3 (i, level, 0));
		} else {
			rand = Random.value;
			if (rand < boxProb) {
				GameObject box = Instantiate (boxPrefab);
				box.transform.Translate (new Vector3 (i, level, 0));
			} else {
				rand = Random.value;
				if (rand < monsterProb) {
					GameObject monster = Instantiate (monsterPrefab);
					monster.transform.Translate (new Vector3 (i, level, 0));
				}
			}
		}
	}
	void Start () {
		for (int i = 0; i < 100; ++i) {
			float rand = Random.value;
			if (rand < groundProb) {
				GameObject ground = Instantiate (groundPrefab);
				ground.transform.Translate (new Vector3 (i, 0, 0));
			
				generateGameObjects (i, 0);
			}
			rand = Random.value;
			if (rand < level1Prob) {
				GameObject level1 = Instantiate (levelPrefab);
				level1.transform.Translate (new Vector3 (i, 0, 0));

				generateGameObjects (i, 1);

				rand = Random.value;
				if (rand < level2Prob) {
					GameObject level2 = Instantiate (levelPrefab);
					level2.transform.Translate (new Vector3 (i, 1, 0));

					generateGameObjects (i, 2);
				}
			}
		}
	}
	
	// Update is called once per frame
	void Update () {
		
	}
}
